package eu.axes.services.shotextractor;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.net.URI;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.FilenameUtils;
import org.apache.commons.io.filefilter.RegexFileFilter;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.content.api.ContentManager;
import org.ow2.weblab.core.extended.exception.WebLabCheckedException;
import org.ow2.weblab.core.extended.factory.SegmentFactory;
import org.ow2.weblab.core.extended.factory.WebLabResourceFactory;
import org.ow2.weblab.core.model.Annotation;
import org.ow2.weblab.core.model.Document;
import org.ow2.weblab.core.model.Image;
import org.ow2.weblab.core.model.TemporalSegment;
import org.ow2.weblab.core.model.Video;
import org.ow2.weblab.core.model.processing.WProcessingAnnotator;
import org.purl.dc.elements.DublinCoreAnnotator;

import eu.axes.utils.AXES;
import eu.axes.utils.AxesAnnotator;

/**
 * This class is a parser in charge of reading the content of the folder where shots and frames have been generated after a call to shot-detector and frame-extractor.
 *
 * @author ymombrun
 * @date 2014-11-20
 */
public final class ShotDirectoryParser {


	private static final String SHOT_OUT_PREFIX = "s";


	private static final String SHOT_IN_PREFIX = "";


	private static final String SHOT_DIR = "s";


	private static final String FPS_AND_NB_FRAMES = "info";


	private static final String SCENE_CUT = "scenecut";


	private static final String STABLE_FRAME = "stableframe";


	private static final String FRAME_INFO = "frame.pts";


	/**
	 * Regex check that shots folder are just numbers.
	 */
	private static final FilenameFilter SHOT_FILE_FILTER = new RegexFileFilter("s\\d+");


	private final Document document;


	private final File directory;


	private final Log log;


	private final File fpsFile;


	private final File scenecutFile;


	private final File stableFrameFile;


	private final Video mainVideo;


	private final AxesAnnotator mainAA;


	private final WProcessingAnnotator mainWPA;


	private final ContentManager contentManager;


	private final ShotExtractorConfigBean conf;


	private final String collectionId;


	/**
	 * @param directory
	 *            Folder of the video
	 * @param document
	 *            Document to be enriched
	 * @param conf
	 *            The configuration
	 */
	public ShotDirectoryParser(final File directory, final Document document, final ShotExtractorConfigBean conf) {
		this.log = LogFactory.getLog(this.getClass());
		this.conf = conf;
		this.directory = directory;
		this.document = document;
		this.scenecutFile = new File(directory, ShotDirectoryParser.SCENE_CUT);
		this.stableFrameFile = new File(directory, ShotDirectoryParser.STABLE_FRAME);
		this.fpsFile = new File(directory, ShotDirectoryParser.FPS_AND_NB_FRAMES);
		this.contentManager = ContentManager.getInstance();
		this.mainVideo = (Video) this.document.getMediaUnit().get(0);
		this.collectionId = FilenameUtils.getName(directory.getParent());

		final Annotation videoAnnotation = WebLabResourceFactory.createAndLinkAnnotation(this.mainVideo);
		this.mainWPA = new WProcessingAnnotator(URI.create(this.mainVideo.getUri()), videoAnnotation);
		if ((this.conf.getServiceUri() != null) && !this.conf.getServiceUri().isEmpty() && (this.conf.getServiceValidUri() != null)) {
			this.mainWPA.startInnerAnnotatorOn(URI.create(videoAnnotation.getUri()));
			this.mainWPA.writeProducedBy(this.conf.getServiceValidUri());
			this.mainWPA.endInnerAnnotator();
		}
		this.mainAA = new AxesAnnotator(URI.create(this.mainVideo.getUri()), videoAnnotation);

		this.log.debug("ShotDirectoryParser created on '" + directory + "' for document '" + document + "'" + " out of collection '" + this.collectionId + "'.");
	}


	/**
	 * Checks that in the path provided to the constructor of this class various folders and files exists so that we can read them in order to enriched the provided Document.
	 *
	 * @return <code>true</code> if the directory, shot directory, fps file, scene cut file and stable frames file exist, are readable and are of the appropriate type (directory or file).
	 */
	public boolean isValid() {
		return this.isScenecutValid() && ShotDirectoryParser.isFolderReadable(this.directory) && ShotDirectoryParser.isFileReadable(this.fpsFile);
	}


	/**
	 * Checks that in the path provided to the constructor of this class the various files generated by the shot_detector script exists. It is necessary to run the second script, ie the frame
	 * extractor.
	 *
	 * @return <code>true</code> if the directory, scene cut file and stable frames file exist, are readable and are of the appropriate type (directory or file).
	 */
	public boolean isScenecutValid() {
		return (this.scenecutFile != null) && (this.stableFrameFile != null) && ShotDirectoryParser.isFolderReadable(this.directory) && ShotDirectoryParser.isFileReadable(this.scenecutFile)
				&& ShotDirectoryParser.isFileReadable(this.stableFrameFile);
	}


	/**
	 * Process the folder provided in the constructor method in order to enrich the provided document with annotations.
	 *
	 * @throws IOException
	 */
	public void enrichWithShotAndFrames() throws IOException {
		final String[] fpsNbFrames = this.readFPSNbFrames();

		final double msPerFrame = 1000 / Double.parseDouble(fpsNbFrames[2]);

		this.log.debug("Number of ms elapsed between each frame: " + msPerFrame);

		final int[] sceneCuts = this.readSceneCuts(msPerFrame);

		this.log.debug("SceneCuts file read: " + Arrays.toString(sceneCuts));

		final int nbShots = this.directory.listFiles(ShotDirectoryParser.SHOT_FILE_FILTER).length;

		if (nbShots > (sceneCuts.length + 1)) {
			throw new IOException("Shot directory is not consistent. " + sceneCuts.length + " scene cuts found. " + nbShots + " shots folder found.");
		} else if (nbShots < (sceneCuts.length + 1)) {
			this.log.warn("Shot directory is not consistent. " + sceneCuts.length + " scene cuts found. Only " + nbShots + " shots folder found. Processing anyway. Some shots might have no frames.");
		}

		final String docUri = this.document.getUri();

		final NumberFormat fmt = NumberFormat.getIntegerInstance();
		fmt.setGroupingUsed(false);
		fmt.setMinimumIntegerDigits(9);
		for (int i = 1; i <= sceneCuts.length + 1; i++) {
			final String shotIdIn = SHOT_IN_PREFIX + fmt.format(i);
			final String shotIdOut = SHOT_OUT_PREFIX + fmt.format(i);
			final File framesDirectory = new File(this.directory, SHOT_DIR + shotIdIn + "/");

			// Create a temporal segment representing the shot (start and end are set later).
			final TemporalSegment shotSegment = SegmentFactory.createAndLinkSegment(this.mainVideo, TemporalSegment.class);

			// Annotate the created segment as shot segment and annotate the shot Id
			this.mainAA.startInnerAnnotatorOn(URI.create(shotSegment.getUri()));
			this.mainAA.writeType(AXES.CLASSES.SHOT_SEGMENT);
			this.mainAA.writeShotId(shotIdOut);
			this.mainAA.endInnerAnnotator();

			final Map<String, Long> frameMap = ShotDirectoryParser.readFrameInfo(framesDirectory);

			int minFrame = Integer.MAX_VALUE, maxFrame = -1;
			if (framesDirectory.exists() && framesDirectory.isDirectory()) {
				for (final File frameFile : FileUtils.listFiles(framesDirectory, this.conf.getFramesFileFilter(), null)) {
					final TemporalSegment seg;
					try {
						seg = this.createFrameSegments(FilenameUtils.getBaseName(this.directory.getName()), shotIdOut, frameFile, frameMap);
					} catch (final WebLabCheckedException wlce) {
						this.log.warn("An error occurs processing frame " + frameFile + " for video " + docUri + ". Skipping this frame.", wlce);
						continue;
					}
					minFrame = Math.min(minFrame, seg.getStart());
					maxFrame = Math.max(maxFrame, seg.getEnd());
				}
			}

			if ((minFrame == Integer.MAX_VALUE) && (maxFrame == -1)) {
				this.log.warn("Not a single frame found for shot " + shotIdIn);
			}

			// Start is the previous cutting value (in frame nb converted into ms) or 0 for the first shot.
			int start = (i == 1) ? 0 : (sceneCuts[i - 2]);
			if (start > minFrame) {
				this.log.warn("At least one frame is located at " + minFrame + " which is before the start of shot " + shotIdOut + " in video " + docUri + ". (Start is " + start + ").");
				start = minFrame;
			}

			// End is the cutting value minus one (in frame nb converted into ms) or nb frames for the last shot.
			int end = (int) ((i == (sceneCuts.length + 1)) ? ShotDirectoryParser.getMillisFromTime(fpsNbFrames[1]) : (sceneCuts[i - 1] - 1));
			if (end < maxFrame) {
				this.log.warn("At least one frame is located at " + maxFrame + " which is after the end of shot " + shotIdOut + " in video " + docUri + ". (End is " + end + ").");
				end = maxFrame;
			}

			shotSegment.setStart(start);
			shotSegment.setEnd(end);
		}

	}


	private static double getMillisFromTime(final String time) {
		final String[] dotSplit = time.split("\\.");
		final String[] ddotSplit = dotSplit[0].split(":");
		final double min = (Double.parseDouble(ddotSplit[0]) * 60) + Double.parseDouble(ddotSplit[1]);
		final double sec = (min * 60) + Double.parseDouble(ddotSplit[2]);
		final double millis = (sec * 1000) + (Double.parseDouble(dotSplit[1]) * 10);
		return millis;
	}


	private TemporalSegment createFrameSegments(final String videoId, final String shotId, final File frameFile, final Map<String, Long> frameMap) throws WebLabCheckedException {
		// Depending on the version of the shot detector binary, frame name can start by keyframe, by kf, by k or by nothing.
		final String frameId = FilenameUtils.getBaseName(frameFile.getName()).replace("keyframe", "").replace("kf", "").replace("k", "");

		// Create the frame and its segment
		final Image frameMediaUnit = WebLabResourceFactory.createAndLinkMediaUnit(this.document, Image.class);
		final TemporalSegment frameSegment = SegmentFactory.createAndLinkSegment(this.mainVideo, TemporalSegment.class);

		// Set its position (start == end)
		final int position = frameMap.get(frameId).intValue();
		frameSegment.setStart(position);
		frameSegment.setEnd(position);

		// Links the temporal segment to the extracted frame
		this.mainWPA.startInnerAnnotatorOn(URI.create(frameSegment.getUri()));
		this.mainWPA.writeDelimiterOfFrameUnit(URI.create(frameMediaUnit.getUri()));
		this.mainWPA.writeType(AXES.CLASSES.FRAME_SEGMENT);
		this.mainWPA.endInnerAnnotator();

		this.mainAA.startInnerAnnotatorOn(URI.create(frameSegment.getUri()));
		this.mainAA.writeShotId(shotId);
		this.mainAA.writeFrameId("keyframe" + frameId);
		this.mainAA.endInnerAnnotator();

		// Create annotators for the frame it self
		final Annotation annotOnFrame = WebLabResourceFactory.createAndLinkAnnotation(frameMediaUnit);
		final AxesAnnotator frameAA = new AxesAnnotator(URI.create(frameMediaUnit.getUri()), annotOnFrame);
		final WProcessingAnnotator frameWPA = new WProcessingAnnotator(URI.create(frameMediaUnit.getUri()), annotOnFrame);
		if (this.conf.getServiceUri() != null) {
			frameWPA.startInnerAnnotatorOn(URI.create(annotOnFrame.getUri()));
			frameWPA.writeProducedBy(this.conf.getServiceValidUri());
			frameWPA.endInnerAnnotator();
		}

		// Links the frame to the video that generates it (i.e. now always the main video)
		frameWPA.writeFrameOf(URI.create(this.mainVideo.getUri()));
		frameWPA.writeLocatedAt(URI.create(frameSegment.getUri()));
		// Describe the frame
		frameAA.writeShotId(shotId);
		frameAA.writeFrameId("keyframe" + frameId);
		frameAA.writeVideoId(videoId);
		frameAA.writeCollectionId(this.collectionId);

		// Save the frame in the content manager and annotate the frame with the content id
		final DublinCoreAnnotator dca = new DublinCoreAnnotator(URI.create(frameMediaUnit.getUri()), annotOnFrame);
		dca.writeFormat(this.conf.getFramesMimeType());
		final URI nativeContentUri = this.contentManager.writeNativeContent(frameFile, frameMediaUnit);
		dca.startInnerAnnotatorOn(nativeContentUri);
		dca.writeFormat(this.conf.getFramesMimeType());
		dca.endInnerAnnotator();

		return frameSegment;
	}


	private int[] readSceneCuts(final double msPerFrame) throws IOException {
		final List<String> lines = FileUtils.readLines(this.scenecutFile, "UTF-8");
		if (lines.isEmpty()) {
			throw new IOException("The scenecut file is empty.");
		}

		final String nbShotStr = lines.get(0);
		final int nbShot;
		try {
			nbShot = Integer.parseInt(nbShotStr);
		} catch (final NumberFormatException nfe) {
			throw new IOException("Unable to parse number of shots from " + nbShotStr + ".", nfe);
		}

		if (nbShot == 0) {
			this.log.info("This file has not shot boundaries. It is a single shot video");
			return new int[0];
		}

		if (lines.size() < 2) {
			throw new IOException("The scenecut file is contains less than two lines.");
		}

		final String[] sceneCutsStr = lines.size() >= 3 ? StringUtils.split(lines.get(2)) : StringUtils.split(lines.get(1));
		if (sceneCutsStr.length != nbShot) {
			throw new IOException("The scenecut file is inconsistant. It says having " + nbShot + " scene cuts, but " + sceneCutsStr.length + " cuting frames are described.");
		}

		final int[] sceneCuts = new int[sceneCutsStr.length];
		if (lines.size() >= 3) {
			for (int i = 0; i < sceneCutsStr.length; i++) {
				try {
					sceneCuts[i] = (int) (Double.parseDouble(sceneCutsStr[i]) * 1000);
				} catch (final NumberFormatException nfe) {
					throw new IOException("Unable to parse scene cut frame timestamp from " + sceneCutsStr[i] + ".", nfe);
				}
			}
		} else {
			// This depends on the version shot detector used. In fact, the version released has never the above line.
			this.log.trace("No third line in scenecut file " + this.scenecutFile.getAbsolutePath() + " estimating using frames number and frame rate.");
			for (int i = 0; i < sceneCutsStr.length; i++) {
				try {
					sceneCuts[i] = (int) (Integer.parseInt(sceneCutsStr[i]) * msPerFrame);
				} catch (final NumberFormatException nfe) {
					throw new IOException("Unable to parse scene cut frame number from " + sceneCutsStr[i] + ".", nfe);
				}
			}
		}

		return sceneCuts;
	}


	private String[] readFPSNbFrames() throws IOException {
		final String[] fpsNbFramesStr = StringUtils.split(FileUtils.readFileToString(this.fpsFile, "UTF-8"));
		if (fpsNbFramesStr.length != 3) {
			throw new IOException("Unable to parse fps and nb frames from file  " + this.fpsFile + ".");
		}

		return fpsNbFramesStr;
	}


	private static Map<String, Long> readFrameInfo(final File parent) throws IOException {
		final String[] frameInfos = StringUtils.split(FileUtils.readFileToString(FileUtils.getFile(parent, ShotDirectoryParser.FRAME_INFO), "UTF-8"), "\n");
		final Map<String, Long> result = new HashMap<>();

		for (final String string : frameInfos) {
			final String[] shotInfo = StringUtils.split(string);
			if (shotInfo.length != 3) {
				throw new IOException("Unable to read frame info, invalid number of value: " + string + ".");
			}
			result.put(shotInfo[0], Long.valueOf((long) (Double.parseDouble(shotInfo[2]) * 1000)));
		}

		return result;
	}


	/**
	 * @param file
	 *            The {@link File} to be checked
	 * @return <code>true</code> if <code>file</code> exists and is a readable
	 *         file.
	 */
	private static boolean isFileReadable(final File file) {
		return file.exists() && file.canRead() && file.isFile();
	}


	/**
	 * @param folder
	 *            The {@link File} to be checked
	 * @return <code>true</code> if <code>folder</code> exists and is a readable
	 *         directory.
	 */
	private static boolean isFolderReadable(final File folder) {
		return folder.exists() && folder.canRead() && folder.isDirectory();
	}

}
